package dev.fyloz.colorrecipesexplorer.model

import javax.persistence.*

const val IDENTIFIER_MATERIAL_NAME = "material"

@Entity
@Table(name = "mix_type")
data class MixType(
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    override val id: Long?,

    @Column(unique = true)
    override var name: String,

    @OneToOne(cascade = [CascadeType.ALL])
    @JoinColumn(name = "material_id")
    var material: Material
) : NamedModel

// ==== DSL ====
fun mixType(
    id: Long? = null,
    name: String = "name",
    material: Material = material(),
    op: MixType.() -> Unit = {}
) = MixType(id, name, material).apply(op)

fun mixType(
    name: String = "name",
    materialType: MaterialType = materialType(),
    op: MixType.() -> Unit = {}
) = mixType(
    id = null,
    name,
    material = material(name = name, inventoryQuantity = 0f, isMixType = true, materialType = materialType)
).apply(op)
